<?php
/**
 * functions_ordertotalweight
 *
 * @package functions
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: functions_customers.php 4324 2006-08-30 15:25:24Z birdbrain $
 */

////
// Returns the address_format_id for the given country
// TABLES: countries;
function get_order_total_weight($order_id)
{
  global $db;
  $total_weight = 0;

  // Check to see if the weight is already in the order table,
  // if it is then take it from there, if not then calculate it below
  // and update the database.
  $check_order_weight_query = "select total_weight from " . TABLE_ORDERS . "
  				where orders_id = '".(int)$order_id ."'";

  $order_total_weight = $db->Execute($check_order_weight_query);
  $tweight = $order_total_weight->fields['total_weight'];
  if ($tweight != -1)
  	return $tweight;

  $order_weight_query = "select products_quantity, products_id from " . TABLE_ORDERS_PRODUCTS . "
	  			where orders_id ='" . (int)$order_id ."'";

  $product_ordered    = $db->Execute($order_weight_query);

  while (! $product_ordered->EOF)
  {
	  // Get the product id from the table
	  $products_id = $product_ordered->fields['products_id'];
	  $qty         = $product_ordered->fields['products_quantity'];

	  // Get information about the product
    	  $product_query = "select products_id, products_weight, products_priced_by_attribute,
	  	  product_is_always_free_shipping, products_discount_type, products_discount_type_from,
                  products_virtual, products_model from " . TABLE_PRODUCTS . "
                  where products_id = '" . (int)$products_id . "'";

	  // Here we get the weight of the product and qty
	  if ($product = $db->Execute($product_query))
	  {
	          if ($product->fields['product_is_always_free_shipping'] != 1 and $product->fields['products_virtual'] != 1)
		  {
			$products_weight = $product->fields['products_weight'];
		  } else {
			$products_weight = 0;
		  }
	  
		  $total_weight += ($qty * $products_weight);
	  }

	  // Get information about the product attributes
	  $attribute_weight_query = "select products_attributes_weight, products_attributes_weight_prefix
                  from " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . "
                  where orders_id = '" . (int)$order_id. "'
                  and orders_products_id = '" . (int)$option . "'";

	  $attribute_weight = $db->Execute($attribute_weight_query);
	  while (! $attribute_weight->EOF)
	  {
	  	// adjusted count for free shipping
		  if ($product->fields['product_is_always_free_shipping'] != 1) {
			$new_attributes_weight = $attribute_weight->fields['products_attributes_weight'];
	  	} else {
			$new_attributes_weight = 0;
	  	}

	  	// + or blank adds
	  	if ($attribute_weight->fields['products_attributes_weight_prefix'] == '-') {
			$total_weight -= $qty * $new_attributes_weight;
		} else {
			$total_weight += $qty * $new_attributes_weight;
		}

		$attributes_weight->MoveNext();
	  }

	  $product_ordered->MoveNext();
  }

  // Update the database
  $update_order_weight_query = "update " . TABLE_ORDERS . "
  				set total_weight='". (float)$total_weight."' where orders_id = '".(int)$order_id ."'";
  $db->Execute($update_order_weight_query);

  return $total_weight;
}
